// $Id: smodels_program_impl.h,v 1.1 2004/08/02 18:34:44 jean Exp $

#ifndef PLATYPUS_SMODELS_PROGRAM_IMPL_H
#define PLATYPUS_SMODELS_PROGRAM_IMPL_H

#include <iosfwd>
#include <string>
#include <memory>
#include <interfaces/program_impl.h>

namespace Platypus
{
	class SmodelsHolder;
	class SmodelsHolderFactory;
	class SmodelsEnhancedProgram : public Program
	{
		typedef std::auto_ptr<SmodelsHolderFactory> SafeFactory;
		SafeFactory factory_;
		void init();
	public:
		~SmodelsEnhancedProgram();
		SmodelsEnhancedProgram();
		void setup(const std::string& input);
		void setup(std::istream& input);
		SmodelsHolder* create() const;
	};
}

#endif
